<?php
return Array(
	'freebsd_release' => Array(
		'label' => 'FreeBSD (RELEASE)',
		'services' => Array(
			'http' => Array(
				'label' => $lng['admin']['configfiles']['http'],
				'daemons' => Array(
					'apache' => Array(
						'label' => 'Apache',
						'commands' => Array(
							'mkdir -p ' . $settings['system']['apacheconf_htpasswddir'],
							'touch ' . $settings['system']['apacheconf_vhost'],
							'touch ' . $settings['system']['apacheconf_diroptions'],
							'mkdir -p ' . $settings['system']['documentroot_prefix'],
							'mkdir -p ' . $settings['system']['logfiles_directory'],
							'echo "Include etc/apache22/syscp/vhosts.conf" >> /usr/local/etc/apache22/httpd.conf',
						),
						'restart' => Array(
							'/usr/local/etc/rc.d/apache22 graceful'
						)
					)
				)
			),
			'dns' => Array(
				'label' => $lng['admin']['configfiles']['dns'],
				'daemons' => Array(
					'bind' => Array(
						'label' => 'Bind9',
						'commands' => Array(
							'echo \'include "syscp_bind.conf";\' >> '.$settings['system']['bindconf_directory'].'named.conf',
							'touch ' . $settings['system']['bindconf_directory'] . 'syscp_bind.conf'
						),
						'restart' => Array(
							'/usr/sbin/rndc reload'
						)
					),
				)
			),
			'mail' => Array(
				'label' => $lng['admin']['configfiles']['mail'],
				'daemons' => Array(
					'dovecot' => Array(
						'label' => 'Dovecot',
						'commands' => Array(
							'mkdir -p /etc/ssl/dovecot',
							'cd /etc/ssl/dovecot',
							'openssl req -new -x509 -nodes -out cert.pem -keyout key.pem -days 365',
							'chmod 0600 *.pem'
						),
						'files' => Array(
							'etc_dovecot.conf' => '/usr/local/etc/dovecot.conf',
							'etc_dovecot-sql.conf' => '/usr/local/etc/dovecot-sql.conf'
						),
						'restart' => Array(
							'/usr/local/etc/rc.d/dovecot restart'
						)
					),
				)
			),
			'smtp' => Array(
				'label' => $lng['admin']['configfiles']['smtp'],
				'daemons' => Array(
					'postfix' => Array(
						'label' => 'Postfix',
						'files' => Array(
							'etc_postfix_main.cf' => '/usr/local/etc/postfix/main.cf',
							'etc_postfix_master.cf' => '/usr/local/etc/postfix/master.cf',
							'etc_postfix_mysql-virtual_alias_maps.cf' => '/usr/local/etc/postfix/mysql-virtual_alias_maps.cf',
							'etc_postfix_mysql-virtual_mailbox_domains.cf' => '/usr/local/etc/postfix/mysql-virtual_mailbox_domains.cf',
							'etc_postfix_mysql-virtual_mailbox_maps.cf' => '/usr/local/etc/postfix/mysql-virtual_mailbox_maps.cf'
						),
						'commands' => Array(
							'mkdir -p ' . $settings['system']['vmail_homedir'],
							'chown -R postfix:postfix ' . $settings['system']['vmail_homedir'],
							'mkdir -p /etc/ssl/postfix',
							'cd /etc/ssl/postfix',
							'openssl req -new -x509 -nodes -out smtpd.pem -keyout smtpd.pem -days 3650',
							'chmod 750 /etc/ssl/postfix',
							'chmod 640 /etc/ssl/postfix/smtpd.pem',
							'chgrp -R postfix /etc/ssl/postfix',
							'chmod 640 /usr/local/etc/postfix/mysql-virtual_*',
							'chgrp postfix /usr/local/etc/postfix/mysql-virtual_*'
						),
						'restart' => Array(
							'/usr/local/etc/rc.d/postfix reload'
						)
					),
				)
			),
			'ftp' => Array(
				'label' => $lng['admin']['configfiles']['ftp'],
				'daemons' => Array(
					'proftpd' => Array(
						'label' => 'ProFTPd',
						'commands' => Array(
							'mkdir -p /etc/ssl/proftpd',
							'cd /etc/ssl/proftpd',
							'openssl req -new -x509 -days 365 -nodes -out cert.pem -keyout key.pem',
							'chmod 640 *.pem'
						),
						'files' => Array(
							'etc_proftpd.conf' => '/usr/local/etc/proftpd.conf'
						),
						'restart' => Array(
							'/usr/local/etc/rc.d/proftpd restart'
						)
					),
				)
			),
			'etc' => Array(
				'label' => $lng['admin']['configfiles']['etc'],
				'daemons' => Array(
					'cron' => Array(
						'label' => 'Crond (cronscript)',
						'files' => Array(
							'cron_syscp' => 'crontab -e (As root)'
						)
					)
				)
			)
		)
	)
);

?>
