<?php

/**
 * This file is part of the SysCP project.
 * Copyright (c) 2003-2009 the SysCP Team (see authors).
 *
 * For the full copyright and license information, please view the COPYING
 * file that was distributed with this source code. You can also view the
 * COPYING file online at http://files.syscp.org/misc/COPYING.txt
 *
 * @copyright  (c) the authors
 * @author     Tim Zielosko <tim.zielosko@syscp.de>
 * @author     Aldo Reset <aldo.reset@placenet.org>
 * @author     Romain MARIADASSOU <roms2000@free.fr>
 * @license    GPLv2 http://files.syscp.org/misc/COPYING.txt
 * @package    Language
 * @version    $Id: french.lng.php 2692 2009-03-27 18:04:47Z flo $
 */

/**
 * Some importants rules of typograhie in french :
 * These signs << ! ? : " & >> must be be preceded by white space
 *   ->  We can make the white space like that : << &nbsp; >>
 *   ->  so the white space is still committed to the previous letter and punctuation mark as follows.
 * These signs << . ; , ' >> should be glued to the previous letter
 * These signs << / | = >> would be preceded and followed with a white as mush as possible, it is much clear from reading.
 */

/**
 * Global
 */

$lng['translator'] = 'Tim Zielosko, Aldo Reset, Romain MARIADASSOU';
$lng['panel']['edit'] = 'Modifier';
$lng['panel']['delete'] = 'Supprimer';
$lng['panel']['create'] = 'Ajouter';
$lng['panel']['save'] = 'Sauvegarder';
$lng['panel']['yes'] = 'Oui';
$lng['panel']['no'] = 'Non';
$lng['panel']['emptyfornochanges'] = 'Laissez vide pour ne pas modifier';
$lng['panel']['emptyfordefault'] = 'Laissez vide pour l\'option standard';
$lng['panel']['path'] = 'Dossier';
$lng['panel']['toggle'] = 'Activer / Dsactiver';
$lng['panel']['next'] = 'continuer';
$lng['panel']['dirsmissing'] = 'Dossiers non disponibles ou illisibles';

/**
 * Login
 */

$lng['login']['username'] = 'Identifiant';
$lng['login']['password'] = 'Mot de passe';
$lng['login']['language'] = 'Langue';
$lng['login']['login'] = 'Se connecter';
$lng['login']['logout'] = 'Se dconnecter';
$lng['login']['profile_lng'] = 'Langue du profil';

/**
 * Customer
 */

$lng['customer']['documentroot'] = 'Chemin';
$lng['customer']['name'] = 'Nom';
$lng['customer']['firstname'] = 'Prnom';
$lng['customer']['company'] = 'Entreprise';
$lng['customer']['street'] = 'Rue';
$lng['customer']['zipcode'] = 'Code postal';
$lng['customer']['city'] = 'Ville';
$lng['customer']['phone'] = 'Tlphone';
$lng['customer']['fax'] = 'Fax';
$lng['customer']['email'] = 'E-mail';
$lng['customer']['customernumber'] = 'Numro du client';
$lng['customer']['diskspace'] = 'Espace Web (Mo)';
$lng['customer']['traffic'] = 'Trafic (Go)';
$lng['customer']['mysqls'] = 'Base(s) de donnes MySQL';
$lng['customer']['emails'] = 'Adresse(s) e-mail';
$lng['customer']['accounts'] = 'Accs e-mail';
$lng['customer']['forwarders'] = 'Transfert(s) e-mail';
$lng['customer']['ftps'] = 'Accs FTP';
$lng['customer']['subdomains'] = 'Sous-domaine(s)';
$lng['customer']['domains'] = 'Domaine(s)';
$lng['customer']['unlimited'] = 'illimit';

/**
 * Customermenue
 */

$lng['menue']['main']['main'] = 'Gnral';
$lng['menue']['main']['changepassword'] = 'Changer de mot de passe';
$lng['menue']['main']['changelanguage'] = 'Changer de langue';
$lng['menue']['email']['email'] = 'E-mail';
$lng['menue']['email']['emails'] = 'Adresse(s) e-mail(s)';
$lng['menue']['email']['webmail'] = 'Webmail';
$lng['menue']['mysql']['mysql'] = 'MySQL';
$lng['menue']['mysql']['databases'] = 'Bases de donnes';
$lng['menue']['mysql']['phpmyadmin'] = 'phpMyAdmin';
$lng['menue']['domains']['domains'] = 'Domaines';
$lng['menue']['domains']['settings'] = 'Paramtres des sites';
$lng['menue']['ftp']['ftp'] = 'FTP';
$lng['menue']['ftp']['accounts'] = 'Comptes d\'accs FTP';
$lng['menue']['ftp']['webftp'] = 'WebFTP';
$lng['menue']['extras']['extras'] = 'Extras';
$lng['menue']['extras']['directoryprotection'] = 'Protection des dossiers';
$lng['menue']['extras']['pathoptions'] = 'Options des dossiers';

/**
 * Index
 */

$lng['index']['customerdetails'] = 'Informations personnelles';
$lng['index']['accountdetails'] = 'Informations du compte';

/**
 * Change Password
 */

$lng['changepassword']['old_password'] = 'Ancien mot de passe';
$lng['changepassword']['new_password'] = 'Nouveau mot de passe';
$lng['changepassword']['new_password_confirm'] = 'Nouveau mot de passe (confirmation)';
$lng['changepassword']['new_password_ifnotempty'] = 'Nouveau mot de passe (Veuillez laisser vide pour ne pas changer)';
$lng['changepassword']['also_change_ftp'] = 'Changer aussi le mot de passe du compte FTP principal ?';

/**
 * Domains
 */

$lng['domains']['description'] = 'Ici, vous pouvez ajouter des sites et domaines et changer leurs doosiers.<br />Il vous faudra patienter quelques minutes aprs chaque changement pour que la configuration soit active.';
$lng['domains']['domainsettings'] = 'Configuration des Domaines';
$lng['domains']['domainname'] = 'Nom du Domaine';
$lng['domains']['subdomain_add'] = 'Ajouter un sous-domaine';
$lng['domains']['subdomain_edit'] = 'Changer un sous-domaine';
$lng['domains']['wildcarddomain'] = 'Domaine gnrique (Wilcard) ?';
$lng['domains']['aliasdomain'] = 'Alias pour le domaine';
$lng['domains']['noaliasdomain'] = 'Domaine sans alias';

/**
 * E-mails
 */

$lng['emails']['description'] = 'Ici, vous pouvez ajouter vos botes e-mails.<br><br>Les informations pour configurer votre logiciel e-mail sont les suivantes : <br><br>Nom du serveur : <b><i>votre-domaine.com</i></b><br>Identifiant : <b><i>l\'adresse e-mail</i></b><br>Mot de passe : <b><i>le mot de passe que vous avez choisi</i></b>';
$lng['emails']['emailaddress'] = 'Adresse';
$lng['emails']['emails_add'] = 'Ajouter une adresse e-mail';
$lng['emails']['emails_edit'] = 'Changer une adresse e-mail';
$lng['emails']['catchall'] = 'Catchall';
$lng['emails']['iscatchall'] = 'Dfinir comme adresse "catchall" ?';
$lng['emails']['account'] = 'Accs';
$lng['emails']['account_add'] = 'Ajouter un accs';
$lng['emails']['account_delete'] = 'Supprimer l\'accs';
$lng['emails']['from'] = 'de';
$lng['emails']['to'] = '';
$lng['emails']['forwarders'] = 'Rexpdition';
$lng['emails']['forwarder_add'] = 'Ajouter un renvoi';

/**
 * FTP
 */

$lng['ftp']['description'] = 'Ici, vous pouvez ajouter des accs FTP supplmentaires.<br />Les changements, ainsi que l\'accs, sont immdiatement oprationnels.';
$lng['ftp']['account_add'] = 'Ajouter un accs';

/**
 * MySQL
 */

$lng['mysql']['databasename'] = 'Nom de la base de donnes';
$lng['mysql']['databasedescription'] = 'Description de la base de donnes';
$lng['mysql']['database_create'] = 'Ajouter une base de donnes';

/**
 * Extras
 */

$lng['extras']['description'] = 'Ici, vous pouvez ajouter des extras, comme par exemple, la protection de dossiers du site.<br />Il vous faudra patienter quelques minutes aprs chaque changement pour que la configuration soit active.';
$lng['extras']['directoryprotection_add'] = 'Ajouter une protection de dossier';
$lng['extras']['view_directory'] = 'Aperu du dossier';
$lng['extras']['pathoptions_add'] = 'Ajouter des options sur le dossier';
$lng['extras']['directory_browsing'] = 'Afficher le contenu des dossiers';
$lng['extras']['pathoptions_edit'] = 'Modifier les options de dossier';
$lng['extras']['error404path'] = '404';
$lng['extras']['error403path'] = '403';
$lng['extras']['error500path'] = '500';
$lng['extras']['error401path'] = '401';
$lng['extras']['errordocument404path'] = 'Emplacement du document "Erreur 404"';
$lng['extras']['errordocument403path'] = 'Emplacement du document "Erreur 403"';
$lng['extras']['errordocument500path'] = 'Emplacement du document "Erreur 500"';
$lng['extras']['errordocument401path'] = 'Emplacement du document "Erreur 401"';

/**
 * Errors
 */

$lng['error']['error'] = 'Erreur';
$lng['error']['directorymustexist'] = 'Le dossier que vous avez choisi n\'existe pas. Veuillez ajouter le dossier avec votre client FTP.';
$lng['error']['filemustexist'] = 'Le fichier que vous avez slectionn n\'existe pas.';
$lng['error']['allresourcesused'] = 'Vous avez dj utilis toutes les ressources.';
$lng['error']['domains_cantdeletemaindomain'] = 'Vous ne pouvez pas supprimer un domaine qui est utilis pour des adresses e-mails.';
$lng['error']['domains_canteditdomain'] = 'Vous n\'avez pas le droit de configurer ce domaine.';
$lng['error']['domains_cantdeletedomainwithemail'] = 'Vous ne pouvez pas supprimer un domaine qui est utilis pour des e-mails. Vous devez d\'abord supprimer toutes les adresses e-mails qu\'il contient.';
$lng['error']['firstdeleteallsubdomains'] = 'Il faut d\'abord supprimer tous les sous-domaines avant d\'ajouter un domaine "wildcard".';
$lng['error']['youhavealreadyacatchallforthisdomain'] = 'Vous avez dj dfini une adresse "catchall" pour ce domaine.';
$lng['error']['ftp_cantdeletemainaccount'] = 'Vous ne pouvez pas supprimer votre accs principal.';
$lng['error']['login'] = 'Identifiant / mot de passe invalide.';
$lng['error']['login_blocked'] = 'Cet identifiant a t bloqu  cause de nombreuses tentatives de connexions invalides.<br />Veuillez ressayer dans ' . $settings['login']['deactivatetime'] . ' secondes.';
$lng['error']['notallreqfieldsorerrors'] = 'Vous n\'avez pas rempli toutes les cases obligatoires ou vous les avez remplis avec des informations invalides.';
$lng['error']['oldpasswordnotcorrect'] = 'L\'ancien mot de passe n\'est pas correct.';
$lng['error']['youcantallocatemorethanyouhave'] = 'Vous ne pouvez pas distribuer plus de ressources qu\'il n\'en reste.';
$lng['error']['mustbeurl'] = 'Vous n\'avez pas entr une adresse URL valide.';
$lng['error']['invalidpath'] = 'Vous n\'avez pas choisi une adresse URL valide (probablement  cause de problmes avec le listing de dossiers ?)';
$lng['error']['stringisempty'] = 'Entre manquante';
$lng['error']['stringiswrong'] = 'Entre invalide';
$lng['error']['myloginname'] = '"' . $lng['login']['username'] . '"';
$lng['error']['mypassword'] = '"' . $lng['login']['password'] . '"';
$lng['error']['oldpassword'] = '"' . $lng['changepassword']['old_password'] . '"';
$lng['error']['newpassword'] = '"' . $lng['changepassword']['new_password'] . '"';
$lng['error']['newpasswordconfirm'] = '"' . $lng['changepassword']['new_password_confirm'] . '"';
$lng['error']['newpasswordconfirmerror'] = 'Le nouveau mot de passe et sa confirmation ne sont pas identiques pas.';
$lng['error']['myname'] = '"' . $lng['customer']['name'] . '"';
$lng['error']['myfirstname'] = '"' . $lng['customer']['firstname'] . '"';
$lng['error']['emailadd'] = '"' . $lng['customer']['email'] . '"';
$lng['error']['mydomain'] = '"domaine"';
$lng['error']['mydocumentroot'] = '"Documentroot"';
$lng['error']['loginnameexists'] = 'L\'identifiant "%s" existe dj.';
$lng['error']['emailiswrong'] = 'L\'adresse "%s" contient des signes invalides ou est incomplte.';
$lng['error']['loginnameiswrong'] = 'L\'identifiant "%s" contient des signes invalides.';
$lng['error']['userpathcombinationdupe'] = 'Cette combinaison d\'identifiant et de dossier existe dj.';
$lng['error']['patherror'] = 'Erreur gnrale ! Le dossier ne doit pas tre vide.';
$lng['error']['errordocpathdupe'] = 'Il y a dj une option concernant le dossier "%s".';
$lng['error']['adduserfirst'] = 'Vous devez d\'abord ajouter un.';
$lng['error']['domainalreadyexists'] = 'Le domaine "%s" existe dj.';
$lng['error']['nolanguageselect'] = 'Aucune langue choisis.';
$lng['error']['nosubjectcreate'] = 'Il faut entrer un sujet.';
$lng['error']['nomailbodycreate'] = 'Il faut entrer un corps de texte.';
$lng['error']['templatenotfound'] = 'Aucun modle trouv.';
$lng['error']['alltemplatesdefined'] = 'Vous avez dj appliqu des modles pour toutes les langues.';
$lng['error']['wwwnotallowed'] = 'Un sous-domaine ne peut pas s\'appeler www.';
$lng['error']['subdomainiswrong'] = 'Le sous-domaine "%s" contient des signes invalides.';
$lng['error']['domaincantbeempty'] = 'Le nom de domaine ne doit pas tre vide.';
$lng['error']['domainexistalready'] = 'Le domaine "%s" existe dj.';
$lng['error']['domainisaliasorothercustomer'] = 'L\'alias du domaine choisi est soit un alias existant d\'un autre client ou soit fait rfrence  lui mme.';
$lng['error']['emailexistalready'] = 'L\'adresse "%s" existe dj.';
$lng['error']['maindomainnonexist'] = 'Le domaine "%s" n\'existe pas.';
$lng['error']['destinationnonexist'] = 'Veuillez crire votre adresse de renvoi  l\'emplacement "".';
$lng['error']['destinationalreadyexistasmail'] = 'Le renvoi vers l\'adresse "%s" existe dj comme adresse active.';
$lng['error']['destinationalreadyexist'] = 'Il existe dj une rexpdition vers l\'adresse "%s".';
$lng['error']['destinationiswrong'] = 'L\'adresse "%s" contient des signes invalides ou est incomplte.';
$lng['error']['domainname'] = $lng['domains']['domainname'];
$lng['error']['youcantdeletechangemainadmin'] = 'Pour des raisons de scurit, il n\'est pas possible de supprimer ou modifier l\'administrateur principal.';
$lng['error']['loginnameissystemaccount'] = 'Vous ne pouvez pas crer un compte identique au compte systme, veuillez ressayer avec un autre nom.';

/**
 * Questions
 */

$lng['question']['question'] = 'Question de scurit';
$lng['question']['admin_customer_reallydelete'] = 'Etes-vous sr de vouloir supprimer le compte "%s" ?<br />ATTENTION ! Toutes ses informations seront supprimes ! Une fois fait, il vous appartiendra de supprimer manuellement tous les dossiers du compte sur le systme de fichiers.';
$lng['question']['admin_domain_reallyenablemailsystemhostname'] = 'Etes-vous sr de vouloir activ le serveur de nom en tant que serveur de mails ?';
$lng['question']['admin_domain_reallydelete'] = 'Etes-vous sr de vouloir supprimer le domaine "%s" ?';
$lng['question']['admin_domain_reallydisablesecuritysetting'] = 'Etes-vous sr de vouloir dsactiver les modes de scurit suivants : OpenBasedir et / o SafeMode ?';
$lng['question']['admin_admin_reallydelete'] = 'Etes-vous sr de vouloir supprimer l\'administrateur "%s" ?<br />Tous ses comptes seront affects  l\'administrateur principal.';
$lng['question']['admin_template_reallydelete'] = 'Etes-vous sr de vouloir supprimer le modle "%s" ?';
$lng['question']['domains_reallydelete'] = 'Etes-vous sr de vouloir supprimer le domaine "%s" ?';
$lng['question']['email_reallydelete'] = 'Etes-vous sr de vouloir supprimer l\'adresse e-mail "%s" ? ';
$lng['question']['email_reallydelete_account'] = 'Etes-vous sr de vouloir supprimer l\'accs e-mail "%s" ?';
$lng['question']['email_reallydelete_forwarder'] = 'Etes-vous sr de vouloir supprimer le renvoi vers "%s" ?';
$lng['question']['extras_reallydelete'] = 'Etes-vous sr de vouloir supprimer la protection du dossier "%s" ?';
$lng['question']['extras_reallydelete_pathoptions'] = 'Etes-vous sr de vouloir supprimer les options du dossier "%s" ?';
$lng['question']['ftp_reallydelete'] = 'Etes-vous sr de vouloir supprimer l\'accs ftp "%s" ?';
$lng['question']['mysql_reallydelete'] = 'Etes-vous sr de vouloir supprimer la base de donnes "%s" ?<br />ATTENTION : Toutes les donnes seront perdues  jamais !';
$lng['question']['admin_configs_reallyrebuild'] = 'Etes-vous sr de vouloir rgnrer les fichiers de configuration Apache et Bind ?';

/**
 * Mails
 */

$lng['mails']['pop_success']['mailbody'] = 'Bonjour,\n\nvotre accs POP3 / IMAP {EMAIL}\na t cr avec succs.\n\nCeci est un e-mail gnr automatiquement, veuillez ne pas rpondre  ce message.\n\nCordialement,\nL\'quipe SysCP\nhttp://www.syscp.org';
$lng['mails']['pop_success']['subject'] = 'Accs POP3 / IMAP cr';
$lng['mails']['createcustomer']['mailbody'] = 'Bonjour {FIRSTNAME} {NAME},\n\nVous trouverez ci-dessous vos informations d\'accs au panel d\'administration :\n\nAdresse d\'administration : http://demo.syscp.org\n\nIdentifiant : {USERNAME}\nMot de passe : {PASSWORD}\n\nCordialement,\nL\'quipe SysCP\nhttp://www.syscp.org\n';
$lng['mails']['createcustomer']['subject'] = 'SysCP : Informations pour votre accs au panel d\'administration';

/**
 * Admin
 */

$lng['admin']['overview'] = 'Sommaire';
$lng['admin']['ressourcedetails'] = 'Ressources utilises';
$lng['admin']['systemdetails'] = 'Informations du systme';
$lng['admin']['syscpdetails'] = 'Informations de SysCP';
$lng['admin']['installedversion'] = 'Version installe';
$lng['admin']['latestversion'] = 'Dernire version en date';
$lng['admin']['lookfornewversion']['clickhere'] = 'Vrifier par internet';
$lng['admin']['lookfornewversion']['error'] = 'Erreur pour vrifier la dernire version';
$lng['admin']['resources'] = 'Ressources';
$lng['admin']['customer'] = 'Compte';
$lng['admin']['customers'] = 'Comptes';
$lng['admin']['customer_add'] = 'Ajouter un compte';
$lng['admin']['customer_edit'] = 'Modifier un compte';
$lng['admin']['domains'] = 'Domaines';
$lng['admin']['domain_add'] = 'Ajouter un domaine';
$lng['admin']['domain_edit'] = 'Modifier le domaine';
$lng['admin']['subdomainforemail'] = 'Sous-domaines comme domaine e-mail';
$lng['admin']['admin'] = 'Administrateur';
$lng['admin']['admins'] = 'Administrateurs';
$lng['admin']['admin_add'] = 'Ajouter un administrateur';
$lng['admin']['admin_edit'] = 'Modifier un administrateur';
$lng['admin']['customers_see_all'] = 'Peut voir tous les comptes ?';
$lng['admin']['domains_see_all'] = 'Peut voir tous les Domaines ?';
$lng['admin']['change_serversettings'] = 'Peut modifier la configuration du serveur ?';
$lng['admin']['server'] = 'Serveur';
$lng['admin']['serversettings'] = 'Paramtres';
$lng['admin']['rebuildconf'] = 'Rgnrer la configuration';
$lng['admin']['stdsubdomain'] = 'Sous-domaine type';
$lng['admin']['stdsubdomain_add'] = 'Ajouter un sous-domaine type';
$lng['admin']['phpenabled'] = 'PHP activ';
$lng['admin']['deactivated'] = 'Dsactiver';
$lng['admin']['deactivated_user'] = 'Dsactiver l\'utilisateur';
$lng['admin']['sendpassword'] = 'Envoyer le mot de passe';
$lng['admin']['ownvhostsettings'] = 'Configuration spciale du vHost';
$lng['admin']['configfiles']['serverconfiguration'] = 'Exemple de configuration';
$lng['admin']['configfiles']['files'] = '<b>Fichiers de configuration :</b> Veuillez crer ou modifier les fichiers suivants avec le contenu ci-dessous.<br /><br /><b>IMPORTANT :</b> Le mot de passe MySQL n\'est pas donn dans les informations ci-dessous<br />pour des raisons de scurit. Veuillez donc remplacer les "<b>MYSQL_PASSWORD</b>"<br />manuellement avec le mot de passe correspondant. En cas d\'oubli, vous pouvez le retrouver dans<br />le fichier "<b>lib/userdata.inc.php</b>".';
$lng['admin']['configfiles']['commands'] = '<b>Commandes :</b> Veuillez excuter les commandes ci-dessous dans le shell.';
$lng['admin']['configfiles']['restart'] = '<b>Redmarrage :</b> Veuillez excuter les commandes ci-dessous pour<br />prendre en compte les changements.';
$lng['admin']['templates']['templates'] = 'Modles';
$lng['admin']['templates']['template_add'] = 'Ajouter un modle';
$lng['admin']['templates']['template_edit'] = 'Modifier un modle';
$lng['admin']['templates']['action'] = 'Action';
$lng['admin']['templates']['email'] = 'E-mail';
$lng['admin']['templates']['subject'] = 'Rfrence';
$lng['admin']['templates']['mailbody'] = 'Texte de l\'e-mail';
$lng['admin']['templates']['createcustomer'] = 'E-mail de bienvenue pour les nouveaux clients';
$lng['admin']['templates']['pop_success'] = 'E-mail de bienvenue pour les nouveaux accs e-mail';
$lng['admin']['templates']['template_replace_vars'] = 'Les variables qui seront remplaces dans le template :';
$lng['admin']['templates']['FIRSTNAME'] = 'Sera remplac par le prnom.';
$lng['admin']['templates']['NAME'] = 'Sera remplac par le nom.';
$lng['admin']['templates']['USERNAME'] = 'Sera remplac par le login.';
$lng['admin']['templates']['PASSWORD'] = 'Sera remplac par le mot de passe du client.';
$lng['admin']['templates']['EMAIL'] = 'Sera remplac par l\'accs e-mail.';

/**
 * Serversettings
 */

$lng['serversettings']['session_timeout']['title'] = 'Dure d\'inactivit maximale';
$lng['serversettings']['session_timeout']['description'] = 'Combien de secondes d\'inactivit avant qu\'une session ne se ferme ?';
$lng['serversettings']['accountprefix']['title'] = 'Prfix des comptes';
$lng['serversettings']['accountprefix']['description'] = 'Quel prfix doivent avoir les comptes ?';
$lng['serversettings']['mysqlprefix']['title'] = 'Prfix SQL';
$lng['serversettings']['mysqlprefix']['description'] = 'Quel prfix doivent avoir les bases de donnes ?';
$lng['serversettings']['ftpprefix']['title'] = 'Prfix FTP';
$lng['serversettings']['ftpprefix']['description'] = 'Quel prfix doivent avoir les accs FTP ?';
$lng['serversettings']['documentroot_prefix']['title'] = 'Dossier de stockage';
$lng['serversettings']['documentroot_prefix']['description'] = 'O doivent tre stocks tous les dossiers et fichiers des diffrents comptes ?';
$lng['serversettings']['logfiles_directory']['title'] = 'Dossier des fichiers de log';
$lng['serversettings']['logfiles_directory']['description'] = 'O doivent tre stocks les archives des logs d\'accs du serveur Web ?';
$lng['serversettings']['ipaddress']['title'] = 'Adresse IP';
$lng['serversettings']['ipaddress']['description'] = 'Quelle est l\'adresse IP du serveur ?';
$lng['serversettings']['hostname']['title'] = 'Nom d\'hte';
$lng['serversettings']['hostname']['description'] = 'Quel est le nom d\'hte (hostname) du serveur ?';
$lng['serversettings']['apachereload_command']['title'] = 'Commande de rechargement d\'Apache';
$lng['serversettings']['apachereload_command']['description'] = 'Quelle est la commande pour recharger / redmarrer Apache ?';
$lng['serversettings']['apacheconf_filename']['title'] = 'Nom du fichier de configuration Apache';
$lng['serversettings']['apacheconf_filename']['description'] = 'Dans quel fichier souhaitez-vous enregistrer la configuration Apache ?';
$lng['serversettings']['bindconf_directory']['title'] = 'Emplacement du dossier de configuration de Bind / Named';
$lng['serversettings']['bindconf_directory']['description'] = 'O doit tre stock la configuration de Bind / Named ?';
$lng['serversettings']['bindreload_command']['title'] = 'Commande de rechargement de Bind / Named';
$lng['serversettings']['bindreload_command']['description'] = 'Quelle est la commande pour recharger / redmarrer Bind / Named ?';
$lng['serversettings']['binddefaultzone']['title'] = 'Nom du fichier de zone par dfaut Bind / Named';
$lng['serversettings']['binddefaultzone']['description'] = 'Quel est le nom du fichier de zone par dfaut pour Bind / Named ?';
$lng['serversettings']['vmail_uid']['title'] = 'UID des e-mails';
$lng['serversettings']['vmail_uid']['description'] = 'Quel UID doivent avoir les e-mails ?';
$lng['serversettings']['vmail_gid']['title'] = 'GID des e-mails';
$lng['serversettings']['vmail_gid']['description'] = 'Quel GID doivent avoir les e-mails ?';
$lng['serversettings']['vmail_homedir']['title'] = 'Emplacement des e-mails';
$lng['serversettings']['vmail_homedir']['description'] = 'Dans quel dossier doivent tre stocker les e-mails ?';
$lng['serversettings']['adminmail']['title'] = 'Adresse e-mail de l\'administrateur';
$lng['serversettings']['adminmail']['description'] = 'Quelle est l\'adresse e-mail par dfaut des e-mails envoys par SysCP ?';
$lng['serversettings']['phpmyadmin_url']['title'] = 'Adresse URL de phpMyAdmin';
$lng['serversettings']['phpmyadmin_url']['description'] = 'A quelle adresse se trouve phpMyAdmin ?';
$lng['serversettings']['webmail_url']['title'] = 'Adresse URL du WebMail';
$lng['serversettings']['webmail_url']['description'] = 'A quelle adresse se trouve le WebMail ?';
$lng['serversettings']['webftp_url']['title'] = 'Adresse URL du WebFTP';
$lng['serversettings']['webftp_url']['description'] = 'A quelle adresse se trouve le WebFTP ?';
$lng['serversettings']['language']['description'] = 'Quelle langue est la langue par dfaut ?';
$lng['serversettings']['maxloginattempts']['title'] = 'Nombre d\'essais maximum avant dsactivation';
$lng['serversettings']['maxloginattempts']['description'] = 'Nombre de tentatives maximum avant la dsactivation de l\'accs.';
$lng['serversettings']['deactivatetime']['title'] = 'Dure de la dsactivation';
$lng['serversettings']['deactivatetime']['description'] = 'Dure (en secondes) pendant laquelle l\'accs sera dsactiv.';
$lng['serversettings']['pathedit']['title'] = 'Mode de slection des dossiers';
$lng['serversettings']['pathedit']['description'] = 'Choisir un dossier par une liste droulante ou l\'entrer manuellement ?';
$lng['serversettings']['nameservers']['title'] = 'Serveurs de nom &laquo;Nameservers&raquo;';
$lng['serversettings']['nameservers']['description'] = 'Une liste spare par des virgules contenant les noms d\'htes de tous les serveurs de noms. Le premier dans la liste sera le serveur primaire.';
$lng['serversettings']['mxservers']['title'] = 'Serveurs de messagerie &laquo;MX&raquo;';
$lng['serversettings']['mxservers']['description'] = 'Une liste spare par des virgules contenant les serveurs de messagerie avec leur poid : un nombre et le nom d\'hte spar par un espace; par exemple : "10 mx.exemple.com".';

/**
 * CHANGED BETWEEN 1.2.12 and 1.2.13
 */

$lng['mysql']['description'] = 'Ici, vous pouvez ajouter et effacer des bases de donnes MySQL.<br>Les changements, ainsi que les bases de donnes, sont immdiatement oprationnels.<br>Dans le menu, vous trouverez un lien vers phpMyAdmin, avec lequel vous pouvez grer vos bases de donnes.<br><br>L\'accs aux bases de donnes depuis les scripts PHP fonctionne comme suit : (Il faut remplacer les valeurs en <i><b>italique</b></i> par vos informations !)<br><br>$connexion = mysql_connect(\'localhost\', \'<i><b>Votre identifiant</b></i>\', \'<i><b>Votre mot de passe</b></i>\');<br>mysql_select_db(\'<i><b>Le nom de la base de donnes</b></i>\', $connexion);';

/**
 * ADDED BETWEEN 1.2.12 and 1.2.13
 */

$lng['admin']['cronlastrun'] = 'Dernire tche "cron"';
$lng['serversettings']['paging']['title'] = 'Nombre de rsultats par page';
$lng['serversettings']['paging']['description'] = 'Nombre de rsultats par page ? (0 = Dsactive la pagination)';
$lng['error']['ipstillhasdomains'] = 'La combinaison IP / port est encore utilise, veuillez rassigner le ou les domaines existant(s) avec cette adresse IP / port concern(s)  une autre combinaison IP / port avant de supprimer celle-ci.';
$lng['error']['cantdeletedefaultip'] = 'Vous ne pouvez pas supprimer cette combinaison IP / Port, veuillez d\'abord attribuer une autre combinaison IP / Port par dfaut  ce revendeur avant de supprimer celle-ci.';
$lng['error']['cantdeletesystemip'] = 'Vous ne pouvez pas crer, modifier ou supprimer l\'IP du systme.';
$lng['error']['myipaddress'] = '"IP"';
$lng['error']['myport'] = '"Port"';
$lng['error']['myipdefault'] = 'Choissez une combinaison IP / port par dfaut.';
$lng['error']['myipnotdouble'] = 'Cette combinaison existe dj.';
$lng['question']['admin_ip_reallydelete'] = 'Etes-vous sr de vouloir supprimer l\'adresse IP "%s" ?';
$lng['admin']['ipsandports']['ipsandports'] = 'IPs et ports';
$lng['admin']['ipsandports']['add'] = 'Ajouter une IP / port';
$lng['admin']['ipsandports']['edit'] = 'Modifier une IP / port';
$lng['admin']['ipsandports']['ipandport'] = 'IP / Port';
$lng['admin']['ipsandports']['ip'] = 'IP';
$lng['admin']['ipsandports']['port'] = 'Port';

// ADDED IN 1.2.13-rc3

$lng['error']['cantchangesystemip'] = 'Vous ne pouvez pas modifier l\'adresse IP du systme, ni en ajouter de nouvelle.';
$lng['question']['admin_domain_reallydocrootoutofcustomerroot'] = 'Etes-vous sr de vouloir diffrencier la racine principale de ce domaine de la racine principale du client ?';

// ADDED IN 1.2.14-rc1

$lng['admin']['memorylimitdisabled'] = 'Dsactiv';
$lng['domain']['openbasedirpath'] = 'Dossier "OpenBasedir"';
$lng['domain']['docroot'] = 'Identique au dossier ci-dessus';
$lng['domain']['homedir'] = 'Dossier Principal';
$lng['admin']['valuemandatory'] = 'Cette valeur est obligatoire';
$lng['admin']['valuemandatorycompany'] = 'Vous devez indiquer au moins l\'une des 3 valeurs suivantes : "nom" ou "prnom" ou "entreprise"';
$lng['menue']['main']['username'] = 'Utilisateur : ';
$lng['panel']['urloverridespath'] = 'URL (supplante la valeur dossier)';
$lng['panel']['pathorurl'] = 'Dossier ou URL';
$lng['error']['sessiontimeoutiswrong'] = 'Seule une valeur numrique pour le temps d\'inactivit est autorise.';
$lng['error']['maxloginattemptsiswrong'] = 'Seule une valeur numrique pour "nombre maximum de tentative de connexion" est autorise.';
$lng['error']['deactivatetimiswrong'] = 'Seule une valeur numrique pour la dure de dsactivation est autorise.';
$lng['error']['accountprefixiswrong'] = 'Le "Prfixe client" n\'est pas valide.';
$lng['error']['mysqlprefixiswrong'] = 'Le "Prfixe SQL" n\'est pas valide.';
$lng['error']['ftpprefixiswrong'] = 'Le "Prfixe FTP" n\'est pas valide.';
$lng['error']['ipiswrong'] = 'L\'"Adresse IP" n\'est pas valide.';
$lng['error']['vmailuidiswrong'] = 'L\'"UID e-mail" est incorrect. Seul un UID numrique est autoris.';
$lng['error']['vmailgidiswrong'] = 'Le "GID e-mail" est incorrect. Seul un GID numrique est autoris.';
$lng['error']['adminmailiswrong'] = 'L\'adresse e-mail de l\'administrateur est incorrect. Seulement une adresse e-mail valide est autoris.';
$lng['error']['pagingiswrong'] = 'La valeur "Nombre de rsultats page" est incorrecte. Seul une valeur numrique est autorise.';
$lng['error']['phpmyadminiswrong'] = 'Le lien pour phpMyAdmin n\'est pas valide.';
$lng['error']['webmailiswrong'] = 'Le lien pour le WebMail n\'est pas valide.';
$lng['error']['webftpiswrong'] = 'Le lien pour le WebFTP n\'est pas valide.';
$lng['domains']['hasaliasdomains'] = 'Le domaine possde un ou des alias.';
$lng['domains']['istopleveldomain'] = 'Est le nom de domaine principal';
$lng['serversettings']['defaultip']['title'] = 'IP / Port par dfaut';
$lng['serversettings']['defaultip']['description'] = 'Quel est l\'IP / Port par dfaut ?';
$lng['domains']['statstics'] = 'Frquentation';
$lng['panel']['ascending'] = 'ascendant';
$lng['panel']['decending'] = 'descendant';
$lng['panel']['search'] = 'Rechercher';
$lng['panel']['used'] = 'utilis';

// ADDED IN 1.2.14-rc3

$lng['panel']['translator'] = 'Traducteur(s)';

// ADDED IN 1.2.14-rc4

$lng['error']['stringformaterror'] = 'La valeur pour "%s" n\'est pas dans un format reconnu.';

// ADDED IN 1.2.15-rc1

$lng['admin']['serversoftware'] = 'Logiciel Serveur';
$lng['admin']['phpversion'] = 'Version de PHP';
$lng['admin']['phpmemorylimit'] = 'Limite mmoire de PHP';
$lng['admin']['mysqlserverversion'] = 'Version du serveur MySQL';
$lng['admin']['mysqlclientversion'] = 'Version du client MySQL';
$lng['admin']['webserverinterface'] = 'Interface Web';
$lng['domains']['isassigneddomain'] = 'Le domaine est attribu';
$lng['serversettings']['phpappendopenbasedir']['title'] = 'Dossier(s) de l\'OpenBasedir';
$lng['serversettings']['phpappendopenbasedir']['description'] = 'Liste de dossiers spare par des virgules qui sera ajout  la variable "OpenBasedir" des conteneurs vHosts.';

// CHANGED IN 1.2.15-rc1

$lng['error']['loginnameissystemaccount'] = 'Vous ne pouvez pas crer de compte ressemblant aux comptes systme (ex : "%s"). Veuillez entrer un autre nom de compte.';
$lng['error']['youcantdeleteyourself'] = 'Vous ne pouvez pas supprimer votre propre compte pour des raisons vidente de scurit ...';
$lng['error']['youcanteditallfieldsofyourself'] = 'Note : Vous ne pouvez pas diter tous les champs de votre propre compte pour des raisons de scurit.';

// ADDED IN 1.2.16-svn1

$lng['serversettings']['natsorting']['title'] = 'Utiliser un tri naturel dans les diffrentes vues';
$lng['serversettings']['natsorting']['description'] = 'Trier les listes comme web1 -> web2 -> etc ... -> web11 au lieu de web1 -> web11 -> web2.';

// ADDED IN 1.2.16-svn2

$lng['serversettings']['deactivateddocroot']['title'] = 'Dossier "DocumentRoot" pour les utilisateurs dsactivs';
$lng['serversettings']['deactivateddocroot']['description'] = 'Quand un utilisateur est dsactiv, ce dossier sera utilis comme dossier racine pour le serveur Web. Laissez vide pour ne pas crer de vHost et ne rien afficher du tout lorsque l\'utilisateur est dsactiv.';

// ADDED IN 1.2.16-svn4

$lng['panel']['reset'] = 'Ignorer les changements';
$lng['admin']['accountsettings'] = 'Paramtres du compte';
$lng['admin']['panelsettings'] = 'Paramtres du panel';
$lng['admin']['systemsettings'] = 'Paramtres du systme';
$lng['admin']['webserversettings'] = 'Paramtres du serveur Web';
$lng['admin']['mailserversettings'] = 'Paramtres du serveur de Mail';
$lng['admin']['nameserversettings'] = 'Paramtres du serveur de Noms';
$lng['admin']['updatecounters'] = 'Recalculer les ressources utilises';
$lng['question']['admin_counters_reallyupdate'] = 'Etes-vous sr de vouloir recalculer les ressources utilises ?';
$lng['panel']['pathDescription'] = 'Si le dossier n\'existe pas, il sera cr automatiquement.';

// ADDED IN 1.2.16-svn6

$lng['mails']['trafficninetypercent']['mailbody'] = 'Bonjour {FIRSTNAME} {NAME},\n\nVous utilisez {TRAFFICUSED} Mo sur {TRAFFIC} Mo de votre quota de trafic.\nCe dernier est  plus de 90%.\n\nCordialement,\nL\'quipe SysCP.';
$lng['mails']['trafficninetypercent']['subject'] = 'Limite de trafic bientt atteinte.';
$lng['admin']['templates']['trafficninetypercent'] = 'E-mail de notification pour les utilisateurs, lorsque leur taux de trafic atteint plus de 90%.';
$lng['admin']['templates']['TRAFFIC'] = 'Sera remplac par le taux de trafic qui a t attribu  l\'utilisateur.';
$lng['admin']['templates']['TRAFFICUSED'] = 'Sera remplac par le taux de trafic qui a t consomm par l\'utilisateur.';

// ADDED IN 1.2.16-svn7

$lng['admin']['subcanemaildomain']['never'] = 'Jamais';
$lng['admin']['subcanemaildomain']['choosableno'] = 'A choisir, par dfaut : non';
$lng['admin']['subcanemaildomain']['choosableyes'] = 'A choisir, par dfaut : oui';
$lng['admin']['subcanemaildomain']['always'] = 'Toujours';
$lng['changepassword']['also_change_webalizer'] = 'Changer aussi le mot de passe des statistiques Webalizer ?';

// ADDED IN 1.2.16-svn8

$lng['serversettings']['mailpwcleartext']['title'] = 'Sauvegarder aussi les mots de passe des comptes e-mails de faon dcrypter dans la base de donnes';
$lng['serversettings']['mailpwcleartext']['description'] = 'Si cela est  Oui, tous les mots de passe seront aussi sauvegarder de faon dcrypter dans la table mail_users (en texte clair pour toutes personnes qui auraient accs  la base de donnes). Activer cette option, uniquement si vous en avez vraiment besoin !';
$lng['serversettings']['mailpwcleartext']['removelink'] = 'Cliquez ici pour retirer tous les mots de passe en texte clair de la base de donnes.';
$lng['question']['admin_cleartextmailpws_reallywipe'] = 'Etes-vous sr de vouloir retirer tous les mots de passe en clairs des comptes e-mails de la table mail_users ? Cette action ne peut tre annule !';
$lng['admin']['configfiles']['overview'] = 'Aperu';
$lng['admin']['configfiles']['wizard'] = 'Assistant';
$lng['admin']['configfiles']['distribution'] = 'Distribution';
$lng['admin']['configfiles']['service'] = 'Service';
$lng['admin']['configfiles']['daemon'] = 'Dmon';
$lng['admin']['configfiles']['http'] = 'Serveur Web (HTTP)';
$lng['admin']['configfiles']['dns'] = 'Serveur de Noms (DNS)';
$lng['admin']['configfiles']['mail'] = 'Serveur de Mails (IMAP/POP3)';
$lng['admin']['configfiles']['smtp'] = 'Serveur de Mails (SMTP)';
$lng['admin']['configfiles']['ftp'] = 'Serveur FTP';
$lng['admin']['configfiles']['etc'] = 'Autres (Systme)';
$lng['admin']['configfiles']['choosedistribution'] = '-- Choisissez une distribution --';
$lng['admin']['configfiles']['chooseservice'] = '-- Choisissez un service --';
$lng['admin']['configfiles']['choosedaemon'] = '-- Choisissez un dmon --';
$lng['admin']['trafficlastrun'] = 'Dernier calcul du trafic';

// ADDED IN 1.2.16-svn10

$lng['serversettings']['ftpdomain']['title'] = 'Comptes FTP @domaine';
$lng['serversettings']['ftpdomain']['description'] = 'Les utilisateurs peuvent-ils crer des comptes FTP de la forme utilisateur@domaine.com ?';
$lng['panel']['back'] = 'Retour';

// ADDED IN 1.2.16-svn12

$lng['serversettings']['mod_log_sql']['title'] = 'Sauvegarder temporairement les logs dans la base de donnes';
$lng['serversettings']['mod_log_sql']['description'] = 'Utiliser <a href="http://www.outoforder.cc/projects/apache/mod_log_sql/" title="mod_log_sql">mod_log_sql</a> pour sauvegarder temporairement les requtes Web.<br /><b>Cela  besoin d\'une configuration spcifique <a href="http://files.syscp.org/docs/mod_log_sql/" title="mod_log_sql - documentation">d\'Apache</a> !</b>';
$lng['serversettings']['mod_fcgid']['title'] = 'Utiliser PHP par mod_fcgid / suexec';
$lng['serversettings']['mod_fcgid']['description'] = 'Utiliser mod_fcgid / suexec / libnss_mysql pour lancer PHP avec le compte correspondant  l\'utilisateur ?<br/><b>Cela  besoin d\'une configuration spcifique d\'Apache !</b>';
$lng['serversettings']['sendalternativemail']['title'] = 'Utiliser une adresse e-mail alternative';
$lng['serversettings']['sendalternativemail']['description'] = 'Envoyer le mot de passe du compte e-mail  une adresse diffrents pour la cration du compte e-mail ?';
$lng['emails']['alternative_emailaddress'] = 'Adresse e-mail alternative';
$lng['mails']['pop_success_alternative']['mailbody'] = 'Bonjour,\n\nVotre compte e-mail {EMAIL} a t correctement cr.\n\nVotre mot de passe est : {PASSWORD}.\n\nCeci est un message gnr automatiquemenent, veuillez ne pas rpondre  cet e-mail car il ne serait tre consulter.\n\nCordialement,\nL\'quipe SysCP.';
$lng['mails']['pop_success_alternative']['subject'] = 'Compte e-mail correctement cr';
$lng['admin']['templates']['pop_success_alternative'] = 'Message de bienvenue envoy  l\'adresse e-mail alternative pour les nouveaux comptes e-mails';
$lng['admin']['templates']['EMAIL_PASSWORD'] = 'Remplacer par le mot de passe du compte POP3 / IMAP.';

// ADDED IN 1.2.16-svn13

$lng['error']['documentrootexists'] = 'Le dossier "%s" existe dj pour cet utilisateur. Veuillez le supprimer / dplacer avant de ressayer l\'ajout de cet utilisateur.';

// ADDED IN 1.2.16-svn14

$lng['serversettings']['apacheconf_vhost']['title'] = 'Dossier / fichier de configuration des vHosts pour Apache';
$lng['serversettings']['apacheconf_vhost']['description'] = 'O doit tre stock le fichier de configuration des vHosts ? Vous pouvez soit entrer le nom d\'un fichier (tous les vHosts dans un seul fichier), soit le nom d\'un dossier (chacun des vHosts dans un fichier spar du dossier).';
$lng['serversettings']['apacheconf_diroptions']['title'] = 'Fichier / dossier de configuration des options des dossiers pour Apache';
$lng['serversettings']['apacheconf_diroptions']['description'] = 'O doit tre stock le fichier de configuration des options de dossiers ? Vous pouvez soit entrer le nom d\'un fichier (toutes les options des dossiers dans un seul fichier), soit le nom d\'un dossier (chacune des options de dossier dans un fichier spar du dossier).';
$lng['serversettings']['apacheconf_htpasswddir']['title'] = 'Dossier du fichier htpasswd pour Apache';
$lng['serversettings']['apacheconf_htpasswddir']['description'] = 'O doit tre stock le fichier de configuration de protection des dossiers "htpasswd" pour Apache ?';

// ADDED IN 1.2.16-svn15

$lng['error']['formtokencompromised'] = 'La requte semble compromise. Pour des raisons de scurit, vous avez t dconnect.';
$lng['serversettings']['mysql_access_host']['title'] = 'Htes de connexion MySQL';
$lng['serversettings']['mysql_access_host']['description'] = 'Une liste spare par des virgules contenant la liste des htes depuis lesquels les utilisateurs sont autoriss  se connecter au serveur MySQL.';

// ADDED IN 1.2.18-svn1

$lng['admin']['ipsandports']['create_listen_statement'] = 'Dclaration des ports d\'coute';
$lng['admin']['ipsandports']['create_namevirtualhost_statement'] = 'Dclaration des htes virtuels "NameVirtualHost"';
$lng['admin']['ipsandports']['create_vhostcontainer'] = 'Dclaration des conteneurs virtuels "vHost"';
$lng['admin']['ipsandports']['create_vhostcontainer_servername_statement'] = 'Dclaration des noms d\'htes "ServerName" dans les conteneurs virtuels "vHost"';

// ADDED IN 1.2.18-svn2

$lng['admin']['webalizersettings'] = 'Paramtres pour Webalizer';
$lng['admin']['webalizer']['normal'] = 'Normal';
$lng['admin']['webalizer']['quiet'] = 'Silencieux';
$lng['admin']['webalizer']['veryquiet'] = 'Aucune sortie';
$lng['serversettings']['webalizer_quiet']['title'] = 'Sortie Webalizer';
$lng['serversettings']['webalizer_quiet']['description'] = 'Verbosit du programme Webalizer';

// ADDED IN 1.2.18-svn3

$lng['ticket']['admin_email'] = 'root@localhost';
$lng['ticket']['noreply_email'] = 'billets@syscp';
$lng['admin']['ticketsystem'] = 'Systme de billets';
$lng['menue']['ticket']['ticket'] = 'Billets de support';
$lng['menue']['ticket']['categories'] = 'Catgories de support';
$lng['menue']['ticket']['archive'] = 'Archives de billets';
$lng['ticket']['description'] = 'Entrez une description !';
$lng['ticket']['ticket_new'] = 'Ouvrir un nouveau billet';
$lng['ticket']['ticket_reply'] = 'Rponse au billet';
$lng['ticket']['ticket_reopen'] = 'Rouvrir le billet';
$lng['ticket']['ticket_newcateory'] = 'Crer une nouvelle catgorie';
$lng['ticket']['ticket_editcateory'] = 'Editer la catgorie';
$lng['ticket']['ticket_view'] = 'Voir l\'historique du billet';
$lng['ticket']['ticketcount'] = 'Billets';
$lng['ticket']['ticket_answers'] = 'Rponses';
$lng['ticket']['lastchange'] = 'Dernire action';
$lng['ticket']['subject'] = 'Sujet';
$lng['ticket']['status'] = 'Etat';
$lng['ticket']['lastreplier'] = 'Dernire rponse de';
$lng['ticket']['priority'] = 'Priorit';
$lng['ticket']['low'] = '<span class="ticket_low">Basse</span>';
$lng['ticket']['normal'] = '<span class="ticket_normal">Normale</span>';
$lng['ticket']['high'] = '<span class="ticket_high">Haute</span>';
$lng['ticket']['unf_low'] = 'Basse';
$lng['ticket']['unf_normal'] = 'Normale';
$lng['ticket']['unf_high'] = 'Haute';
$lng['ticket']['lastchange'] = 'Dernier changement';
$lng['ticket']['lastchange_from'] = 'Depuis (jj.mm.aaaa)';
$lng['ticket']['lastchange_to'] = 'Jusqu\'au (jj.mm.aaaa)';
$lng['ticket']['category'] = 'Catgorie';
$lng['ticket']['no_cat'] = 'Aucune';
$lng['ticket']['message'] = 'Message';
$lng['ticket']['show'] = 'Voir';
$lng['ticket']['answer'] = 'Rpondre';
$lng['ticket']['close'] = 'Fermer';
$lng['ticket']['reopen'] = 'Rouvrir';
$lng['ticket']['archive'] = 'Archive';
$lng['ticket']['ticket_delete'] = 'Effacer le billet';
$lng['ticket']['lastarchived'] = 'Billets rcemment archivs';
$lng['ticket']['archivedtime'] = 'Archiv';
$lng['ticket']['open'] = 'Ouvert';
$lng['ticket']['wait_reply'] = 'Attente d\'une rponse';
$lng['ticket']['replied'] = 'Rpondu';
$lng['ticket']['closed'] = 'Ferm';
$lng['ticket']['staff'] = 'L\'quipe';
$lng['ticket']['customer'] = 'Client';
$lng['ticket']['old_tickets'] = 'Messages du billet';
$lng['ticket']['search'] = 'Rechercher dans les archives';
$lng['ticket']['nocustomer'] = 'Aucun choix';
$lng['ticket']['archivesearch'] = 'Rsultat de la recherche dans les archives';
$lng['ticket']['noresults'] = 'Aucun billet trouv';
$lng['ticket']['notmorethanxopentickets'] = 'Pour viter les abus, vous ne pouvez avoir plus de %s billets ouverts';
$lng['ticket']['supportstatus'] = 'Etat du support';
$lng['ticket']['supportavailable'] = '<span class="ticket_low">Nos quipes de support sont disponibles et prtes  vous assister.</span>';
$lng['ticket']['supportnotavailable'] = '<span class="ticket_high">Nos quipes de support ne sont actuellement pas disponibles.</span>';
$lng['admin']['templates']['ticket'] = 'E-mail de notification pour les billets de support';
$lng['admin']['templates']['SUBJECT'] = 'Sera remplac par le sujet du billet de support.';
$lng['admin']['templates']['new_ticket_for_customer'] = 'Informe le client que le billet a t envoy';
$lng['admin']['templates']['new_ticket_by_customer'] = 'Notifie l\'administrateur qu\'un nouveau billet a t ouvert par un client';
$lng['admin']['templates']['new_reply_ticket_by_customer'] = 'Notifie l\'administrateur d\'une rponse du client au billet';
$lng['admin']['templates']['new_ticket_by_staff'] = 'Informe le client qu\'un billet a t ouvert par l\'quipe de support';
$lng['admin']['templates']['new_reply_ticket_by_staff'] = 'Informe le client d\'une rponse de l\'quipe de support au billet';
$lng['mails']['new_ticket_for_customer']['mailbody'] = 'Bonjour {FIRSTNAME} {NAME},\n\nVotre demande de billet de support ayant comme sujet "{SUBJECT}" a t envoy.\n\nVous receverez une notification lorsque votre billet aura une rponse.\n\nMerci,\nL\'quipe SysCP.';
$lng['mails']['new_ticket_for_customer']['subject'] = 'Votre billet de support a t envoy';
$lng['mails']['new_ticket_by_customer']['mailbody'] = 'Bonjour administrateur,\n\nUn nouveau billet de support ayant comme sujet "{SUBJECT}" a t ouvert.\n\nVeuillez vous connecter pour consulter le billet.\n\nMerci,\nl\'quipe SysCP.';
$lng['mails']['new_ticket_by_customer']['subject'] = 'Nouveau billet de support soumis';
$lng['mails']['new_reply_ticket_by_customer']['mailbody'] = 'Bonjour administrateur,\n\nLe billet de support "{SUBJECT}" a reu une rponse de la part du client.\n\nVeuillez vous connecter pour consulter le billet.\n\nMerci,\nL\'quipe SysCP.';
$lng['mails']['new_reply_ticket_by_customer']['subject'] = 'Nouvelle rponse au billet de support';
$lng['mails']['new_ticket_by_staff']['mailbody'] = 'Bonjour {FIRSTNAME} {NAME},\n\nUn billet de support ayant comme sujet "{SUBJECT}" a t ouvert pour vous par notre quipe.\n\nVeuillez vous connecter pour consulter le billet.\n\nMerci,\nL\'quipe SysCP.';
$lng['mails']['new_ticket_by_staff']['subject'] = 'Nouvelle demande de support soumise';
$lng['mails']['new_reply_ticket_by_staff']['mailbody'] = 'Bonjour {FIRSTNAME} {NAME},\n\nLe billet de support ayant comme sujet "{SUBJECT}" a reu une rponse par notre quipe.\n\nVeuillez vous connecter pour consulter le billet.\n\nMerci,\nL\quipe SysCP.';
$lng['mails']['new_reply_ticket_by_staff']['subject'] = 'Nouvelle rponse au billet de support';
$lng['question']['ticket_reallyclose'] = 'Etes-vous sr de vouloir clturer le billet "%s" ?';
$lng['question']['ticket_reallydelete'] = 'Etes-vous sr de vouloir supprimer le billet "%s" ?';
$lng['question']['ticket_reallydeletecat'] = 'Etes-vous sr de vouloir supprimer la catgorie "%s" ?';
$lng['question']['ticket_reallyarchive'] = 'Etes-vous sr de vouloir archiver le billet "%s" ?';
$lng['error']['mysubject'] = '"' . $lng['ticket']['subject'] . '"';
$lng['error']['mymessage'] = '"' . $lng['ticket']['message'] . '"';
$lng['error']['mycategory'] = '"' . $lng['ticket']['category'] . '"';
$lng['error']['nomoreticketsavailable'] = 'Vous n\'avez plus de billets de disponibles. Veuillez contacter votre administrateur.';
$lng['error']['nocustomerforticket'] = 'Ne peut crer de billet sans client';
$lng['error']['categoryhastickets'] = 'La catgorie possde des billets.<br />Veuillez d\'abord supprimer tous les billets de cette catgorie.';
$lng['error']['notmorethanxopentickets'] = $lng['ticket']['notmorethanxopentickets'];
$lng['admin']['ticketsettings'] = 'Paramtres des billets de support';
$lng['admin']['archivelastrun'] = 'Derniers billets archivs';
$lng['serversettings']['ticket']['noreply_email'] = 'Adresse e-mail de non rponse';
$lng['serversettings']['ticket']['noreply_email_desc'] = 'L\'adresse e-mail de l\'expditeur de notification pour les billets de support, quelque chose du type no-reply@domaine.com';
$lng['serversettings']['ticket']['worktime_begin'] = 'Dbut du support (hh:mm)';
$lng['serversettings']['ticket']['worktime_begin_desc'] = 'Horaire de dbut du support';
$lng['serversettings']['ticket']['worktime_end'] = 'Fin du support (hh:mm)';
$lng['serversettings']['ticket']['worktime_end_desc'] = 'Horaire de fin du support';
$lng['serversettings']['ticket']['worktime_sat'] = 'Support disponible le samedi ?';
$lng['serversettings']['ticket']['worktime_sun'] = 'Support disponible le dimanche ?';
$lng['serversettings']['ticket']['worktime_all'] = 'Aucune limite horaire pour le support';
$lng['serversettings']['ticket']['worktime_all_desc'] = 'Si "Oui", les options pour le dbut et la fin du support seront crass.';
$lng['serversettings']['ticket']['archiving_days'] = 'Aprs combien de jours un billet ferm sera automatiquement archiv ?';
$lng['customer']['tickets'] = 'Billet de support';

// ADDED IN 1.2.18-svn4

$lng['admin']['domain_nocustomeraddingavailable'] = 'Il n\'est acutellement pas possible d\'ajouter de domaines. Vous devez d\'abord ajouter un client.';
$lng['serversettings']['ticket']['enable'] = 'Activer le systme de billets';
$lng['serversettings']['ticket']['concurrentlyopen'] = 'Combien  de billets peuvent tre ouverts au mme moment ?';
$lng['error']['norepymailiswrong'] = 'L\'adresse de "non rponse" n\'est pas bonne. Une adresse e-mail valide doit tre entre.';
$lng['error']['tadminmailiswrong'] = 'L\'adresse de "l\'administrateur de billets" n\'est pas bonne. Une adresse e-mail valide doit tre entre.';
$lng['ticket']['awaitingticketreply'] = 'Vous avez %s billet(s) de support non rpondu(s).';

// ADDED IN 1.2.18-svn5

$lng['serversettings']['ticket']['noreply_name'] = 'Nom de l\'expditeur e-mail des billets';

// ADDED IN 1.2.19-svn1

$lng['serversettings']['mod_fcgid']['configdir'] = 'Dossier de configuration FCGI';
$lng['serversettings']['mod_fcgid']['configdir_desc'] = 'O doivent tre stocks les fichiers de configuration pour FCGI ?';
$lng['serversettings']['mod_fcgid']['tmpdir'] = 'Dossier temporaire pour FCGI';

// ADDED IN 1.2.19-svn3

$lng['serversettings']['ticket']['reset_cycle'] = 'Intervalle de rinitialisation des billets utiliss';
$lng['serversettings']['ticket']['reset_cycle_desc'] = 'Remettre le compteur de billets  0 dans le temps imparti';
$lng['admin']['tickets']['daily'] = 'Journalire';
$lng['admin']['tickets']['weekly'] = 'Hebdomadaire';
$lng['admin']['tickets']['monthly'] = 'Mensuelle';
$lng['admin']['tickets']['yearly'] = 'Annuelle';
$lng['error']['ticketresetcycleiswrong'] = 'L\'intervalle de rinitialisation doit tre "journalire", "hebdomadaire", "mensuelle" ou "annuelle".';

// ADDED IN 1.2.19-svn4

$lng['menue']['traffic']['traffic'] = 'Trafic';
$lng['menue']['traffic']['current'] = 'Mois actuel';
$lng['traffic']['month'] = 'Mois';
$lng['traffic']['day'] = 'Jour';
$lng['traffic']['months'][1] = 'Janvier';
$lng['traffic']['months'][2] = 'Fvrier';
$lng['traffic']['months'][3] = 'Mars';
$lng['traffic']['months'][4] = 'Avril';
$lng['traffic']['months'][5] = 'Mai';
$lng['traffic']['months'][6] = 'Juin';
$lng['traffic']['months'][7] = 'Juillet';
$lng['traffic']['months'][8] = 'Aot';
$lng['traffic']['months'][9] = 'Septembre';
$lng['traffic']['months'][10] = 'Octobre';
$lng['traffic']['months'][11] = 'Novembre';
$lng['traffic']['months'][12] = 'Dcembre';
$lng['traffic']['mb'] = 'Trafic (Mo)';
$lng['traffic']['distribution'] = '<font color="#019522">FTP</font> | <font color="#0000FF">HTTP</font> | <font color="#800000">E-mail</font>';
$lng['traffic']['sumhttp'] = 'Trafic HTTP total entrant';
$lng['traffic']['sumftp'] = 'Trafic FTP total entrant';
$lng['traffic']['summail'] = 'Trafic E-mail total entrant';

// ADDED IN 1.2.19-svn4.5

$lng['serversettings']['no_robots']['title'] = 'Permettre aux robots des moteurs de recherche d\'indexer l\'installation de SysCP';

// ADDED IN 1.2.19-svn6

$lng['admin']['loggersettings'] = 'Paramtres des logs';
$lng['serversettings']['logger']['enable'] = 'Activer / Dsactiver les logs';
$lng['serversettings']['logger']['severity'] = 'Niveau de log';
$lng['admin']['logger']['normal'] = 'normal';
$lng['admin']['logger']['paranoid'] = 'paranoaque';
$lng['serversettings']['logger']['types'] = 'Type(s) de log';
$lng['serversettings']['logger']['types_desc'] = 'Spcifiez les types de log spars par des virgules.<br />Les types de log disponible sont : syslog, file, mysql';
$lng['serversettings']['logger']['logfile'] = 'Nom du fichier de log, dossier + nom du fichier';
$lng['error']['logerror'] = 'Erreur log : %s';
$lng['serversettings']['logger']['logcron'] = 'Loguer les travaux de cron (lancer une fois)';
$lng['question']['logger_reallytruncate'] = 'Etes-vous sr de vouloir vider la table "%s" ?';
$lng['admin']['loggersystem'] = 'Log systme';
$lng['menue']['logger']['logger'] = 'Log systme';
$lng['logger']['date'] = 'Date';
$lng['logger']['type'] = 'Type';
$lng['logger']['action'] = 'Action';
$lng['logger']['user'] = 'Utilisateur';
$lng['logger']['truncate'] = 'Vider les logs';

// ADDED IN 1.2.19-svn7

$lng['serversettings']['ssl']['use_ssl'] = 'Utiliser SSL ?';
$lng['serversettings']['ssl']['ssl_cert_file'] = 'O est situ le fichier de certificat ?';
$lng['serversettings']['ssl']['openssl_cnf'] = 'Paramtres par dfaut pour crer le certificat';
$lng['panel']['reseller'] = 'revendeur';
$lng['panel']['admin'] = 'administrateur';
$lng['panel']['customer'] = 'client(s)';
$lng['error']['nomessagetosend'] = 'Vous n\'avez pas entr de message.';
$lng['error']['noreceipientsgiven'] = 'Vous n\'avez pas spcifier de destinataire';
$lng['admin']['emaildomain'] = 'Domaine e-mail';
$lng['admin']['email_only'] = 'Seulement des e-mails ?';
$lng['admin']['wwwserveralias'] = 'Ajouter un "www."  l\'alias du serveur "ServerAlias"';
$lng['admin']['ipsandports']['enable_ssl'] = 'Est-ce un port SSL ?';
$lng['admin']['ipsandports']['ssl_cert_file'] = 'Emplacement du certificat SSL';
$lng['panel']['send'] = 'envoy';
$lng['admin']['subject'] = 'Sujet';
$lng['admin']['receipient'] = 'Destinataire';
$lng['admin']['message'] = 'Ecrire un message';
$lng['admin']['text'] = 'Message';
$lng['menu']['message'] = 'Messages';
$lng['error']['errorsendingmail'] = 'Echec d\'envoi du message  "%s"';
$lng['error']['cannotreaddir'] = 'Impossible de lire dossier "%s"';
$lng['message']['success'] = 'Le message a t envoy aux destinataires "%s"';
$lng['message']['noreceipients'] = 'Aucun e-mail n\'a t envoy car il n\'existe aucun destinataire dans la base de donnes';
$lng['admin']['sslsettings'] = 'Paramtres SSL';
$lng['cronjobs']['notyetrun'] = 'Pas encore lanc';
$lng['install']['servername_should_be_fqdn'] = 'Le nom du serveur doit tre un nom FQDN, pas une adresse IP';
$lng['serversettings']['default_vhostconf']['title'] = 'Paramtres par dfaut pour les vHosts';
$lng['emails']['quota'] = 'Quota';
$lng['emails']['quota_type']['byte'] = 'octet(s)';
$lng['emails']['quota_type']['kilobyte'] = 'Ko';
$lng['emails']['quota_type']['megabyte'] = 'Mo';
$lng['emails']['quota_type']['gigabyte'] = 'Go';
$lng['emails']['noquota'] = 'Pas de quota';
$lng['emails']['updatequota'] = 'Mise  jour';
$lng['serversettings']['mail_quota']['title'] = 'Quota de la bote aux lettres';
$lng['serversettings']['mail_quota']['description'] = 'Quota par dfaut pour toutes nouvelles botes aux lettres cres.';
$lng['serversettings']['mail_quota_enabled']['title'] = 'Utiliser les quotas de botes aux lettres pour les clients';
$lng['serversettings']['mail_quota_enabled']['description'] = 'Activez cette option pour utiliser les quotas sur les botes aux lettres. Par dfaut, cette option est  <b>Non</b> car cela requiert une configuration spcifique.';
$lng['serversettings']['mail_quota_enabled']['removelink'] = 'Cliquez ici pour retirer tous les quotas de tous les comptes e-mails.';
$lng['question']['admin_quotas_reallywipe'] = 'Etes-vous sr de vouloir retirer tous les quotas de la table mail_users ? Cette action ne peut tre annule !';
$lng['error']['vmailquotawrong'] = 'La taille du quota doit tre entre 1 et 999';
$lng['customer']['email_quota'] = 'Quota e-mail';
$lng['customer']['email_imap'] = 'E-mail IMAP';
$lng['customer']['email_pop3'] = 'E-mail POP3';
$lng['customer']['mail_quota'] = 'Quota e-mail';
$lng['error']['invalidip'] = 'Adresse IP invalide : %s';
$lng['serversettings']['decimal_places'] = 'Nombre de dcimales  afficher pour le trafic / espace web';

// ADDED IN 1.2.19-svn8

$lng['admin']['dkimsettings'] = 'Paramtres DKIM';
$lng['dkim']['dkim_prefix']['title'] = 'Prefix DKIM';
$lng['dkim']['dkim_prefix']['description'] = 'Veuillez entrer l\'emplacement des fichiers RSA pour DKIM ainsi que l\'emplacement du fichier de configuration pour le plugin Milter';
$lng['dkim']['dkim_domains']['title'] = 'Nom du fichier DKIM';
$lng['dkim']['dkim_domains']['description'] = '<strong>Nom du fichier</strong> des paramtres DKIM pour les domaines tel que entr dans la configuration de DKIM-milter';
$lng['dkim']['dkim_dkimkeys']['title'] = 'Nom du fichier des clefs DKIM';
$lng['dkim']['dkim_dkimkeys']['description'] = '<strong>Nom du fichier</strong> des paramtres des clefs DKIM tel que entr dans la configuration de DKIM-milter';
$lng['dkim']['dkimrestart_command']['title'] = 'Commande de redmarrage de DKIM-milter';
$lng['dkim']['dkimrestart_command']['description'] = 'Veuillez entrer la commande de redmarrage du service DKIM-milter';

// ADDED IN 1.2.19-svn9

$lng['admin']['caneditphpsettings'] = 'Peut changer les paramtres PHP du domaine ?';

// ADDED IN 1.2.19-svn12

$lng['admin']['allips'] = 'Toutes les adresses IP';
$lng['panel']['nosslipsavailable'] = 'Il n\'y a actuellement aucune combinaison IP / Port configurer pour SSL';
$lng['ticket']['by'] = 'de ';
$lng['dkim']['use_dkim']['title'] = 'Activer le support DKIM ?';
$lng['dkim']['use_dkim']['description'] = 'Voulez-vous utiliser le systme DKIM (DomainKeys Identified Mail) ?';
$lng['error']['invalidmysqlhost'] = 'Adresse hte MySQL invalide : "%s"';
$lng['error']['cannotuseawstatsandwebalizeratonetime'] = 'Vous ne pouvez pas activer AWStats <u>et</u> Webalizer en mme temps. Veuillez n\'en choisir qu\'un seul.';
$lng['serversettings']['webalizer_enabled'] = 'Activer les statistiques Webalizer';
$lng['serversettings']['awstats_enabled'] = 'Activer les statistiques AWStats';
$lng['admin']['awstatssettings'] = 'Paramtres Awstats';
$lng['serversettings']['awstats_domain_file']['title'] = 'Dossier domaines pour AWStats';
$lng['serversettings']['awstats_model_file']['title'] = 'Fichier modle pour AWStats';

// ADDED IN 1.2.19-svn16

$lng['admin']['domain_dns_settings'] = 'Paramtres DNS';
$lng['dns']['destinationip'] = 'IP du domaine';
$lng['dns']['standardip'] = 'IP standard du serveur';
$lng['dns']['a_record'] = 'Enregistrement de type "A" (IPv6 optionnel)';
$lng['dns']['cname_record'] = 'Enregistrement CNAME';
$lng['dns']['mxrecords'] = 'Dfinition des enregistrements MX';
$lng['dns']['standardmx'] = 'Enregistrements MX standard du serveur';
$lng['dns']['mxconfig'] = 'Enregistrements MX personnalis';
$lng['dns']['priority10'] = 'Priorit 10';
$lng['dns']['priority20'] = 'Priorit 20';
$lng['dns']['txtrecords'] = 'Dfinir des enregistrement TXT';
$lng['dns']['txtexample'] = 'Exemple (pour SPF) :<br />v=spf1 ip4:xxx.xxx.xx.0/23 -all';
$lng['serversettings']['selfdns']['title'] = 'Paramtres manuel des DNS du domaine';
$lng['serversettings']['selfdnscustomer']['title'] = 'Permettre aux clients de modifier les paramtes DNS du domaine';
$lng['admin']['activated'] = 'Activ';
$lng['admin']['statisticsettings'] = 'Paramtres des statistiques';
$lng['admin']['or'] = 'ou';

// ADDED IN 1.2.19-svn17

$lng['serversettings']['unix_names']['title'] = 'Utiliser des noms d\'utilisateurs compatible UNIX';
$lng['serversettings']['unix_names']['description'] = 'Vous permet d\'utiliser les <strong>-</strong> et <strong>_</strong> dans les noms d\'utilisateurs si l\'option est  <strong>Non</strong>';
$lng['error']['cannotwritetologfile'] = 'Ne peut ouvrir le fichier de log %s en criture';
$lng['admin']['sysload'] = 'Charge du systme';
$lng['admin']['noloadavailable'] = 'Non disponible';
$lng['admin']['nouptimeavailable'] = 'Non disponible';
$lng['panel']['backtooverview'] = 'Retour  l\'aperu';
$lng['admin']['nosubject'] = '(Aucun sujet)';
$lng['admin']['configfiles']['statistics'] = 'Statistiques';
$lng['login']['forgotpwd'] = 'Mot de passe oubli ?';
$lng['login']['presend'] = 'Rinitialiser le mot de passe';
$lng['login']['email'] = 'Adresse e-mail';
$lng['login']['remind'] = 'Rinitialiser mon mot de passe';
$lng['login']['usernotfound'] = 'Erreur : utilisateur inconnu !';
$lng['pwdreminder']['subject'] = 'SysCP - rinitialisation du mot de passe';
$lng['pwdreminder']['body'] = 'Bonjour %s,\n\nVotre mot de passe pour SysCP a t rinitialiser !\nLe nouveau mot de passe est : %p\n\nCordialement,\nL\'quipe SysCP.';
$lng['pwdreminder']['success'] = 'Mot de passe correctement rinitialiser.<br />Vous devriez recevoir un e-mail avec votre nouveau mot de passe d\'ici quelques minutes.';

// ADDED IN 1.2.19-svn18

$lng['serversettings']['allow_preset'] = 'Permettre aux clients de rinitialiser leurs mots de passe';
$lng['pwdreminder']['notallowed'] = 'La rinitialisation des mots de passe est dsactive.';

// ADDED IN 1.2.19-svn20

$lng['serversettings']['awstats_path']['title'] = 'Dossier CGI-BIN de AWStats';
$lng['serversettings']['awstats_path']['description'] = 'exemple : /var/www/cgi-bin/';
$lng['serversettings']['awstats_updateall_command']['title'] = 'Emplacement de "awstats_updateall.pl"';
$lng['serversettings']['awstats_updateall_command']['description'] = 'exemple : /usr/share/awstats/tools/awstats_updateall.pl';

// ADDED IN 1.2.19-svn21

$lng['customer']['title'] = 'Titre';
$lng['customer']['country'] = 'Pays';
$lng['panel']['dateformat'] = 'YYYY-MM-DD';
$lng['panel']['dateformat_function'] = 'Y-m-d';

// Y = Year, m = Month, d = Day

$lng['panel']['timeformat_function'] = 'H:i:s';

// H = Hour, i = Minute, s = Second

$lng['panel']['default'] = 'Par dfaut';
$lng['panel']['never'] = 'Jamais';
$lng['panel']['active'] = 'Actif';
$lng['panel']['please_choose'] = 'Veuillez choisir';
$lng['panel']['intervalfee_type']['y'] = 'Annes';
$lng['panel']['intervalfee_type']['m'] = 'Mois';
$lng['panel']['intervalfee_type']['d'] = 'Jours';
$lng['panel']['intervalfee_type_one']['y'] = 'Anne';
$lng['panel']['intervalfee_type_one']['m'] = 'Mois';
$lng['panel']['intervalfee_type_one']['d'] = 'Jour';
$lng['panel']['service_still_active'] = 'Le service est toujours actif';
$lng['panel']['allow_modifications'] = 'Permettre les modifications';
$lng['domains']['add_date'] = 'Ajouter  SysCP';
$lng['domains']['registration_date'] = 'Ajouter  l\'enregistrement';
$lng['domains']['topleveldomain'] = 'Domaine de premier niveau';
$lng['admin']['accountdata'] = 'Informations du compte';
$lng['admin']['contactdata'] = 'Informations du contact';
$lng['admin']['servicedata'] = 'Informations du service';
$lng['admin']['billingdata'] = 'Informations de facturation';
$lng['admin']['invoicedata'] = 'Informations de la facture';
$lng['admin']['customer_categories_once'] = 'Inclure des frais d\'installation pour les clients';
$lng['admin']['customer_categories_period'] = 'Inclure des frais priodiques aux clients';
$lng['customer']['taxid'] = 'Numro d\'identification de la taxe';
$lng['customer']['calc_tax'] = 'Calculer le montant des taxes';
$lng['customer']['create_contract'] = 'Crer le contrat';
$lng['customer']['contract_date'] = 'Date du contrat';
$lng['customer']['contract_number'] = 'Description / Numro du contrat';
$lng['customer']['additional_service_description'] = 'Description additionnelle pour le service';
$lng['customer']['contract_details'] = 'Dtails du contrat';
$lng['customer']['included_domains'] = 'Domaines inclus';
$lng['customer']['additional_traffic'] = 'Trafic additionnel';
$lng['customer']['additional_diskspace'] = 'Espace Web additionnel';
$lng['customer']['term_of_payment'] = 'Dlai de paiement';
$lng['customer']['payment_every'] = 'Paiement tous les / toutes les';
$lng['customer']['payment_method'] = 'Moyen de paiement';
$lng['customer']['payment_methods'][CONST_BILLING_PAYMENTMETHOD_BANKTRANSFER] = 'Virement bancaire';
$lng['customer']['payment_methods'][CONST_BILLING_PAYMENTMETHOD_DEBITCARD] = 'Carte de crdit';
$lng['customer']['bankaccount_holder'] = 'Titulaire du compte';
$lng['customer']['bankaccount_number'] = 'Numro de compte';
$lng['customer']['bankaccount_blz'] = 'Numro de la banque';
$lng['customer']['bankaccount_bank'] = 'Nom de la banque';
$lng['service']['quantity'] = 'Quantit';
$lng['service']['interval_fee'] = 'Intervalle de taxation';
$lng['service']['interval_length'] = 'Longueur de l\'intervalle';
$lng['service']['interval_payment'] = 'Intervalle de paiement';
$lng['service']['interval_payment_prepaid'] = 'Prpay / avant paiement';
$lng['service']['interval_payment_postpaid'] = 'Post pay / aprs paiement';
$lng['service']['setup_fee'] = 'Montant des frais d\'installation';
$lng['service']['active'] = 'Service activ';
$lng['service']['start_date'] = 'Activ depuis';
$lng['service']['end_date'] = 'Inactif depuis';
$lng['service']['lastinvoiced_date'] = 'Dernire facture';
$lng['service']['valid_from'] = 'Valide du';
$lng['service']['valid_to'] = 'Valide jusqu\'au';
$lng['invoice']['invoicenumbertemplate'] = 'H-{year}/{number}';
$lng['invoice']['sender'] = '';
$lng['invoice']['invoice'] = 'Facture';
$lng['invoice']['cancellation'] = 'Annuler la facture';
$lng['invoice']['reminder'] = 'Rappel';
$lng['invoice']['preview'] = 'Pr-visualiser';
$lng['invoice']['dateheader'] = 'Fait  %s';
$lng['invoice']['number'] = 'Facture numro';
$lng['invoice']['contract_number'] = 'Numro de contrat';
$lng['invoice']['contract_details'] = 'Dtails du contrat';
$lng['invoice']['contract_details_template'] = 'Contrat d\'hbergement Web %s contenant un espace de %s Mo, ' . chr(128) . 'pour un prix de %s par Go supplmentaires, %s Go de trafic, ' . chr(128) . 'pour un prix de %s par Go supplmentaire; inclus les noms de domaines de %s tous les %s %s';
$lng['invoice']['period'] = 'Priode de facturation';
$lng['invoice']['header'][0] = 'Point de vente';
$lng['invoice']['header'][1] = 'Description';
$lng['invoice']['header'][2] = 'Intervalle';
$lng['invoice']['header'][3] = 'Net [' . chr(128) . ']';
$lng['invoice']['header'][4] = 'Taxe [' . chr(128) . ']';
$lng['invoice']['header'][5] = '%';
$lng['invoice']['header'][6] = 'Total [' . chr(128) . ']';
$lng['invoice']['subtotal'] = 'Sous-total';
$lng['invoice']['tax'] = 'Taxe (%s%%)';
$lng['invoice']['credit_note'] = 'Note de crdit';
$lng['invoice']['total'] = 'Total';
$lng['invoice']['payment_methods'][0] = 'Le montant de la facture  payer dans un dlai de %s jours. ' . "\n" . 'N\'ayant pas encore reu de rglement  ce jour, nous vous prions de vouloir effectuer votre rglement par virement bancaire sur notre compte  crditer. Si vous souhaitez opter pour le prlvement automatique, veuillez remplir le formulaire et nous le renvoyer par courrier postal.';
$lng['invoice']['payment_methods'][1] = 'Le montant de la facture est de %s  notre crdit dans un dlai de %s, sur notre compte numro %s, %s recouvres par prlvement';
$lng['invoice']['tax_text']['line'] = 'T.V.A. %s : %s' . "\n";
$lng['invoice']['tax_text']['client'] = 'du client';
$lng['invoice']['state'] = 'tat';
$lng['invoice']['states'][CONST_BILLING_INVOICESTATE_INVOICED] = 'factur';
$lng['invoice']['states'][CONST_BILLING_INVOICESTATE_SENT] = 'envoy';
$lng['invoice']['states'][CONST_BILLING_INVOICESTATE_PAID] = 'pay';
$lng['invoice']['states'][CONST_BILLING_INVOICESTATE_CANCELLED_NO_REINVOICE] = 'annul (par de refacturation)';
$lng['invoice']['states'][CONST_BILLING_INVOICESTATE_CANCELLED_REINVOICE_WITHOUT_CREDIT_NOTE] = 'annul (refacturation sans note de crdit)';
$lng['invoice']['states'][CONST_BILLING_INVOICESTATE_CANCELLED_REINVOICE_WITH_CREDIT_NOTE] = 'annul (refacturation avec note de crdit)';
$lng['invoice']['states'][CONST_BILLING_INVOICESTATE_CANCELLED_REINVOICED] = 'annul (re-factur)';
$lng['invoice']['state_change'] = 'dernier changement d\'tat';
$lng['invoice']['change_state'] = 'changer l\'tat de la facture';
$lng['invoice']['total_fee'] = 'sans taxe';
$lng['invoice']['total_fee_taxed'] = 'Total';
$lng['invoice']['fix'] = 'Correction de la facture';
$lng['invoice']['pdf'] = 'Crer un PDF';
$lng['invoice']['create_reminder'] = 'Crer un rappel';
$lng['invoice']['changelog'] = 'Historique des changements';
$lng['invoice']['deleted_line'] = 'La ligne a t supprime.';
$lng['invoice']['original_value'] = 'Valeur initiale';
$lng['invoice']['page_footer'] = 'page %s sur %s';
$lng['billing']['billing'] = 'Facturation';
$lng['billing']['invoices'] = 'Factures';
$lng['billing']['invoices_admin'] = 'Factures (Administrateurs)';
$lng['billing']['openinvoices'] = 'Factures ouvertes';
$lng['billing']['openinvoices_admin'] = 'Factures ouvertes (Administrateurs)';
$lng['billing']['cacheinvoicefees'] = 'Mettre  jour la liste / les tarifs';
$lng['billing']['invoice'] = 'Facture';
$lng['billing']['invoice_date'] = 'Date de facture';
$lng['billing']['invoice_fee'] = 'Frais de facture';
$lng['billing']['preview'] = 'Pr-visualiser';
$lng['billing']['caption'] = 'Lgende';
$lng['billing']['number'] = 'Facture numro';
$lng['billing']['caption_setup'] = 'Lgende pour les frais d\'installation';
$lng['billing']['caption_interval'] = 'Lgende pour les frais de gestion interne';
$lng['billing']['template'] = 'Modle';
$lng['billing']['interval'] = 'Intervalle';
$lng['billing']['other'] = 'Autres services';
$lng['billing']['other_add'] = 'Ajouter d\'autres services';
$lng['billing']['other_edit'] = 'Modifier les autres services';
$lng['billing']['taxclassesnrates'] = 'Classifications et montants des taxes';
$lng['billing']['taxclass'] = 'Classification de la taxe';
$lng['billing']['taxrate'] = 'Taux de taxe';
$lng['billing']['taxrate_add'] = 'Ajouter un taux de taxe';
$lng['billing']['taxrate_edit'] = 'Modifier un taux de taxe';
$lng['billing']['domains_templates'] = 'Modle de domaine';
$lng['billing']['domains_templates_add'] = 'Ajouter un modle de domaine';
$lng['billing']['domains_templates_edit'] = 'Modifier un modle de domaine';
$lng['billing']['other_templates'] = 'Autres modles de services';
$lng['billing']['other_templates_add'] = 'Ajouter d\'autres modles de services';
$lng['billing']['other_templates_edit'] = 'Modifier les autres modles de services';
$lng['billing']['categories']['hosting_caption'] = 'Hbergement';
$lng['billing']['categories']['hosting_rowcaption_setup'] = 'Contrat d\'hbergement - Frais d\'installation';
$lng['billing']['categories']['hosting_rowcaption_interval'] = 'Contrat d\'hbergement';
$lng['billing']['categories']['hosting_rowcaption_setup_withloginname'] = 'Contrat d\'hbergement ({loginname}) - Frais d\'installation';
$lng['billing']['categories']['hosting_rowcaption_interval_withloginname'] = 'Contrat d\'hbergement  ({loginname})';
$lng['billing']['categories']['domains_caption'] = 'Domaines';
$lng['billing']['categories']['domains_rowcaption_setup'] = 'Domaine {domain} - Frais d\'installation';
$lng['billing']['categories']['domains_rowcaption_interval'] = 'Domaine {domain}';
$lng['billing']['categories']['traffic_caption'] = 'Trafic';
$lng['billing']['categories']['traffic_rowcaption_setup'] = $lng['billing']['categories']['traffic_rowcaption_interval'] = 'Trafic utilis : {traffic_total}/{traffic_included} Go';
$lng['billing']['categories']['traffic_rowcaption_setup_unlimited'] = $lng['billing']['categories']['traffic_rowcaption_interval_unlimited'] = 'Trafic utilis : {traffic_total}/' . $lng['customer']['unlimited'] . ' Go';
$lng['billing']['categories']['other_caption'] = 'Autre';
$lng['billing']['categories']['other_rowcaption_setup'] = $lng['billing']['categories']['other_rowcaption_interval'] = 'Autre';
$lng['billing']['categories']['diskspace_caption'] = 'Espace Web';
$lng['billing']['categories']['diskspace_rowcaption_setup'] = $lng['billing']['categories']['diskspace_rowcaption_interval'] = 'Espace Web utilis : {diskspace_total}/{diskspace_included} Go';
$lng['billing']['categories']['diskspace_rowcaption_setup_unlimited'] = $lng['billing']['categories']['diskspace_rowcaption_interval_unlimited'] = 'Espace Web utilis : {diskspace_total}/' . $lng['customer']['unlimited'] . ' Go';
$lng['question']['billing_invoice_row_reallydelete'] = 'Etes-vous sr de vouloir supprimer cette ligne de facturation ?';
$lng['question']['billing_invoice_row_reallyreset'] = 'Etes-vous sr de vouloir ignorer tous les changements effectus  cette facture ?';
$lng['question']['billing_invoice_row_reallyreset_key'] = 'Etes-vous sr de vouloir ignorer tous les changements effectus  cette ligne ?';
$lng['question']['billing_domains_template_reallydelete'] = 'Etes-vous sr de vouloir supprimer le modle pour "%s" ?';
$lng['question']['billing_other_template_reallydelete'] = 'Etes-vous sr de vouloir supprimer le modle pour "%s" ?';
$lng['question']['billing_other_service_reallydelete'] = 'Etes-vous sr de vouloir supprimer ce service ?';
$lng['question']['billing_taxrate_reallydelete'] = 'Etes-vous sr de vouloir supprimer ce taux de taxe ?';

// ADDED IN 1.2.19-svn22

$lng['serversettings']['allow_preset_desc'] = 'Les clients peuvent rinitialiser leurs mots de passe et il sera envoy  leurs propres adresses e-mails';
$lng['serversettings']['allow_preset_admin'] = 'Permettre la rinitialisation des mots de passe par les administrateurs';
$lng['serversettings']['allow_preset_admin_desc'] = 'Les administrateurs / revendeurs peuvent rinitialiser leurs mots de passe et il sera envoy  leurs propres adresses e-mails';

// ADDED IN 1.2.19-svn23

$lng['admin']['edit_billingdata'] = 'Peut modifier les informations de facturation ?';
$lng['error']['service_still_active'] = 'Le service est toujours actif.';

// ADDED IN 1.2.19-svn23

$lng['admin']['billingsettings'] = 'Paramtres de facturation';
$lng['serversettings']['billing']['activate_billing']['title'] = 'Activer la facturation';
$lng['serversettings']['billing']['activate_billing']['description'] = 'Ici, vous pouvez activer / dsactiver le systme global de facturation.';
$lng['serversettings']['billing']['highlight_inactive']['title'] = 'Mettre en surbrillance les factures impayes';
$lng['serversettings']['billing']['highlight_inactive']['description'] = 'Est-ce les factures impayes doivent tre mises en surbrillance ?';
$lng['serversettings']['billing']['invoicenumber_count']['title'] = 'Numro de facture actuel';
$lng['serversettings']['billing']['invoicenumber_count']['description'] = 'Est un numro de facture fixe. Lors de tous changements, vous serez amen  en discuter avec votre comptable.';

?>